library IEEE;
use IEEE.std_logic_1164.all;

use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library SYNOPSYS;
use SYNOPSYS.attributes.all;

entity hsyncfsm is 
  port (CLK: in STD_LOGIC;
        I1: in STD_LOGIC;
        I10: in STD_LOGIC;
        I2: in STD_LOGIC;
        I3: in STD_LOGIC;
        I4: in STD_LOGIC;
        I5: in STD_LOGIC;
        I6: in STD_LOGIC;
        I7: in STD_LOGIC;
        I8: in STD_LOGIC;
        I9: in STD_LOGIC;
        HS: out STD_LOGIC;
        VZS: out STD_LOGIC);
end;

architecture hsyncfsm_arch of hsyncfsm is


type Sreg0_type is (S1, S2, S3, S4);
signal Sreg0: Sreg0_type;

begin


Sreg0_machine: process (CLK)

begin

if CLK'event and CLK = '1' then
	case Sreg0 is
		when S1 =>
			if I1 = '1' AND I2 = '1' AND I3 = '1' AND I4 = '1' AND I5 = '1' AND I6 = '0' AND I7 = '0' AND I8 = '0'
				AND I9 ='1' AND I10 = '1' then
				Sreg0 <= S2;
				VZS <= '0';
			end if;
		when S2 =>
			if I1 = '1' AND I2 = '0' AND I3 = '0' AND I4 = '0' AND I5 = '1' AND I6 = '0' AND I7 = '1' AND I8 = '0' AND I9 = '1' AND I10 ='1' then
				Sreg0 <= S3;
				HS <= '1';
			end if;
		when S3 =>
			if I1 = '0' AND I2 = '1' AND I3 = '1' AND I4 = '1' AND I5 = '0' AND I6 = '0' AND I7 = '1' AND I8 = '1'
				AND I9 ='1' AND I10 = '1' then
				Sreg0 <= S4;
				HS <= '0';
			end if;
		when S4 =>
			if I1 = '1' AND I2 = '1' AND I3 = '1' AND I4 = '1' AND I5 = '1' AND I6 = '1' AND I7 = '1' AND I8 = '1'
				AND I9 ='1' AND I10 = '1' then
				Sreg0 <= S1;
				VZS <= '1';
			end if;
		when others =>
			null;
	end case;
end if;
end process;

end hsyncfsm_arch;
